"""This package provides a variety of premix types which can be used to forecast the future state of a time series.

Premixes are layers applied prior to the backbone in a DNN-based forecasting model.
"""

from .base import AbstractPremix, AbstractPremixConfig  # noqa: F401
from .conv import ConvPremix, ConvPremixConfig  # noqa: F401
from .embedding import EmbeddingConfig, EmbeddingPremix, EmbeddingPremixConfig  # noqa: F401
from .identity import IdentityPremix, IdentityPremixConfig  # noqa: F401
